' Test d'Hausman
' estimation du modle  effets fixes
panel.ls(cx=f) y? x1? x2?
vector beta = panel.@coefs
matrix covar = panel.@cov 

' Conservation des termes constants
vector b_fixed = @subextract(beta,1,1,2,1)
matrix cov_fixed = @subextract(covar,1,1,2,2)

' Estimation du modle  effets alatoires et conservation des rsultats
panel.ls(cx=r) y? x1? x2?
beta = panel.@coefs
covar = panel.@cov 

' Conservation des termes constants
vector b_gls = @subextract(beta,2,1,3,1)
matrix cov_gls = @subextract(covar,2,2,3,3)

' Calcul de la statistique d'Hausman
matrix b_diff = b_fixed - b_gls
matrix var_diff = cov_fixed - cov_gls
matrix qform = @transpose(b_diff)*@inverse(var_diff)*b_diff

if qform(1,1)>=0 then
	' Table des rsultats
	table(4,2) result
	setcolwidth(result,1,20)
	setcell(result,1,1,"Test d'Hausman")
	setline(result,2)

	!df = @rows(b_diff)
	setcell(result,3,1,"chi-sqr(" + @str(!df) + ") = ")
	setcell(result,3,2,qform(1,1))
	setcell(result,4,1,"p-value = ")
	setcell(result,4,2,1-@cchisq(qform(1,1),!df))
	setline(result,5)

	show result
else
	statusline "La forme quadratique est ngative"
endif

